<TeXmacs|1.0.6.10>

<style|amsart>

<\body>
  <action|EXPAND|(quail "expand()")>

  <doc-data|<doc-title|parse.tm>>

  This page contains the parser for texmacs documents.

  <\table-of-contents|toc>
    <vspace*|1fn><with|font-series|bold|math-font-series|bold|Table of
    contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-1><vspace|0.5fn>

    <vspace*|1fn><with|font-series|bold|math-font-series|bold|1.<space|2spc>The
    parser> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-2><vspace|0.5fn>

    <vspace*|1fn><with|font-series|bold|math-font-series|bold|2.<space|2spc>The
    different parsing contexts> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-3><vspace|0.5fn>

    <with|par-left|1.5fn|2.1.<space|2spc>Parser error exception
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-4>>

    <with|par-left|1.5fn|2.2.<space|2spc>The event handler decorator
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-5>>

    <with|par-left|1.5fn|2.3.<space|2spc>The base context class
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-6>>

    <with|par-left|1.5fn|2.4.<space|2spc>The document context
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-7>>

    <with|par-left|1.5fn|2.5.<space|2spc>The texmacs tags contexts
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-8>>

    <with|par-left|3fn|2.5.1.<space|2spc>A base class for tag contexts
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-9>>

    <with|par-left|3fn|2.5.2.<space|2spc>Short tag context
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-10>>

    <with|par-left|3fn|2.5.3.<space|2spc>Long tag context
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-11>>

    <with|par-left|1.5fn|2.6.<space|2spc>The concat contexts
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-12>>

    <with|par-left|3fn|2.6.1.<space|2spc>A base class for concat contexts
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-13>>

    <with|par-left|3fn|2.6.2.<space|2spc>The paragraph context
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-14>>

    <with|par-left|3fn|2.6.3.<space|2spc>The tag argument context
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-15>>

    <with|par-left|1.5fn|2.7.<space|2spc>The raw data context
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-16>>

    <with|par-left|1.5fn|2.8.<space|2spc>The collection context
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-17>>

    <vspace*|1fn><with|font-series|bold|math-font-series|bold|3.<space|2spc>Generating
    parse events> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-18><vspace|0.5fn>

    <vspace*|1fn><with|font-series|bold|math-font-series|bold|4.<space|2spc>Removing
    leading white space> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-19><vspace|0.5fn>

    <vspace*|1fn><with|font-series|bold|math-font-series|bold|5.<space|2spc>Text
    encoding in texmacs files> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-20><vspace|0.5fn>
  </table-of-contents>

  <\code>
    @@ buttons

    <with|color|dark red|def> <with|color|blue|expand>():

    \ \ <with|color|dark green|pass>
  </code>

  <section|The parser>

  The main class of the parser is <verbatim|aTexmacsContent>, a special kind
  of string which contains a raw texmacs document and posseses parsing
  capabilities, namely, the property <verbatim|itsTree> parses the content to
  produce a texmacs tree when it is accessed for the first time.

  <\code>
    @@ py parser

    <with|color|dark green|from> quailCenter <with|color|dark green|import>
    quailGet, doDeclareAlias

    doDeclareAlias("", "the parser module")

    doDeclareAlias("aTexmacsContent", "the texmacs content class")

    <with|color|dark green|from> collections <with|color|dark green|import>
    deque

    \;

    <with|color|dark red|class> <with|color|#800080|aTexmacsContent>(str):

    \ \ <with|font-family|rm|A subclass of <verbatim|str> to handle the
    content of texmacs files, with parsing capabilities.>

    \ \ 

    \ \ <with|color|dark red|def> <with|color|blue|__new__>(cls, theContent):

    \ \ \ \ <with|font-family|rm|The line continuations and superfluous white
    space are removed from>

    \ \ \ \ <with|font-family|rm|the texmacs content at creation time.>

    \ \ \ \ removeWhiteSpace = quailGet("remove leading white space")

    \ \ \ \ <with|color|dark green|return> str.__new__(cls,
    removeWhiteSpace(theContent))

    \;

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, *args,
    **kwd):

    \ \ \ \ o._itsTree = None

    \;

    \ \ @property

    \ \ <with|color|dark red|def> <with|color|blue|itsTree>(o):

    \ \ \ \ <with|font-family|rm|Property <verbatim|content.itsTree>
    <math|\<rightarrow\>> <verbatim|aTexmacsTree> instance.>

    \ \ \ \ <with|font-family|rm|The generated tree is stored for subsequent
    calls.>

    \ \ \ \ <with|color|dark green|if> o._itsTree <with|color|dark green|is>
    None: <with|font-family|rm|<math|\<leftarrow\>> the tree must be
    computed.>

    \ \ \ \ \ \ <with|font-family|rm|Initialize the context stack (a
    <verbatim|deque> object).>

    \ \ \ \ \ \ o itsStack = deque()

    \ \ \ \ \ \ <with|font-family|rm|Create an initial parsing context: the
    first paragraph of a document context.>

    \ \ \ \ \ \ theDocument = quailGet("document parsing context")(o, 0)

    \ \ \ \ \ \ generateEvents = quailGet("generate parsing events")

    \ \ \ \ \ \ <with|color|dark green|for> name, pos <with|color|dark
    green|in> generateEvents(o): <with|font-family|rm|<math|\<leftarrow\>>
    iterate over parse events.>

    \ \ \ \ \ \ \ \ <with|font-family|rm|For each event, call the appropriate
    method of the current parsing context,>

    \ \ \ \ \ \ \ \ <with|font-family|rm|passing the event's position in the
    source string. The call>

    \ \ \ \ \ \ \ \ <with|font-family|rm|builds trees and modifies the
    content of the stack. The idea behind this>

    \ \ \ \ \ \ \ \ <with|font-family|rm|is to use python's attribute
    selection mechanism to select the>

    \ \ \ \ \ \ \ \ <with|font-family|rm|parsing action in a given state.>

    \ \ \ \ \ \ \ \ getattr(o itsStack[-1], name)(pos)

    \ \ \ \ \ \ <with|font-family|rm|Send an EOF event to the parsing
    context, as the last event.>

    \ \ \ \ \ \ o itsStack[-1] evEOF(len(o))

    \ \ \ \ \ \ <with|font-family|rm|The current context should be the
    initially created document context.>

    \ \ \ \ \ \ <with|color|dark green|assert>((len(o itsStack) == 1)
    <with|color|dark green|and> (o itsStack[-1] <with|color|dark green|is>
    theDocument))

    \ \ \ \ \ \ o _itsTree = theDocument itsTree
    <with|font-family|rm|<math|\<leftarrow\>> store the resulting tree.>

    \ \ \ \ \ \ <with|color|dark green|del> o itsStack

    \ \ \ \ <with|color|dark green|return> o _itsTree
  </code>

  <section|The different parsing contexts>

  A parsing context responds to parsing events by executing an action, wich
  helps building the parse tree.

  <subsection|Parser error exception>

  <\code>
    @@ py context

    <with|color|dark green|import> binascii

    <with|color|dark green|from> quailCenter <with|color|dark green|import>
    quailGet, doDeclareAlias

    doDeclareAlias("", "the parsing context module")

    TheTmTreeClasses = quailGet("the texmacs tree module") TheTmTreeClasses

    aTmTree = TheTmTreeClasses["aTmTree"]

    theEncodingModule = quailGet("the texmacs text encoding module")

    \;

    <with|color|dark red|class> <with|color|#800080|TexmacsParserError>(Exception):

    \ \ <with|color|dark green|pass>
  </code>

  <subsection|The event handler decorator>

  Context classes methods are mostly event handler. The event handler
  decorator allows to debug the parser by intercepting all calls event
  handler methods.

  <\code>
    @@ py context

    <with|color|dark red|def> <with|color|blue|eventHandler>(func):

    \ \ <with|color|dark green|return> func
  </code>

  <subsection|The base context class>

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxBase>(object):

    \ \ <with|font-family|rm|Base class for parsing contexts.>

    \ \ isVertical = 0

    \;

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent):

    \ \ \ \ <with|font-family|rm|The content is the
    <verbatim|aTexmacsContent> object being parsed.>

    \ \ \ \ o itsContent = theContent

    \ \ \ \ <with|font-family|rm|The context is entered at creation time.>

    \ \ \ \ o itsContent itsStack append(o)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|quit>(o):

    \ \ \ \ <with|font-family|rm|Quit the current context, go back to the
    parent context in the stack.>

    \ \ \ \ o itsContent itsStack pop()

    \;

    \ \ @property

    \ \ <with|color|dark red|def> <with|color|blue|itsParent>(o):

    \ \ \ \ <with|font-family|rm|Get the parent context, if it exists (works
    only for the current context)>

    \ \ \ \ <with|color|dark green|return> o itsContent itsStack[-2]

    \;

    \ \ @property

    \ \ <with|color|dark red|def> <with|color|blue|hasParent>(o):

    \ \ \ \ <with|font-family|rm|works only for the current context.>

    \ \ \ \ <with|color|dark green|return> len(o itsContent itsStack) \<gtr\>
    1

    \;

    \ \ @property

    \ \ <with|color|dark red|def> <with|color|blue|itsClassName>(o):

    \ \ \ \ <with|color|dark green|return> o __class__ __name__

    \;

    \ \ <with|color|dark red|def> <with|color|blue|handleBadEvent>(o):

    \ \ \ \ <with|font-family|rm|Helper for default event handlers.>

    \ \ \ \ <with|font-family|rm|Raises an exception when an unhandled event
    occurred in a subcontext.>

    \ \ \ \ <with|color|dark green|import> sys

    \ \ \ \ theEventName = sys _getframe(1) f_code co_name

    \ \ \ \ <with|color|dark green|raise> TexmacsParserError(

    \ \ \ \ \ \ "Event %s in class aCtxBase (from a %s context)" %

    \ \ \ \ \ \ \ \ \ \ \ (theEventName, o itsClassName))

    \;

    \ \ <with|font-family|rm|Create the default event handlers.>

    \ \ <with|color|dark green|for> theEventName <with|color|dark green|in>
    quailGet("the parsing events names")():

    \ \ \ \ <with|color|dark green|exec>("def %s(o, *args):\\n
    \ o.handleBadEvent()" % theEventName)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|__lshift__>(o, other):

    \ \ \ \ <with|font-family|rm|Adds the tree of other as a child of this
    context's tree (which must exist).>

    \ \ \ \ <with|font-family|rm|'other' is another instance of
    <verbatim|aCtxBase>.>

    \ \ \ \ <with|color|dark green|if> o itsTree <with|color|dark green|is>
    None:

    \ \ \ \ \ \ <with|color|dark green|raise> TexmacsParserError("No tree in
    context %s" % o itsClassName)

    \ \ \ \ o itsTree append(other itsTree)

    \ \ \ \ <with|color|dark green|return> o
  </code>

  <subsection|The document context>

  In a texmacs file, document nodes contain paragraphs, which in turn contain
  the useful text. When the parse enters a document context, it immediately
  create a context for the first paragraph and enters this context.

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxDocument>(aCtxBase):

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    thePosition):

    \ \ \ \ aCtxBase __init__(o, theContent)

    \ \ \ \ o itsTree = TheTmTreeClasses["tm_document"]()
    <with|font-family|rm|<math|\<leftarrow\>>create a document tree.>

    \ \ \ \ <with|color|dark green|if> o hasParent:

    \ \ \ \ \ \ o itsParent \<less\>\<less\> o

    \ \ \ \ <with|font-family|rm|<math|\<searrow\>> create (and enter) the
    first paragraph's context.>

    \ \ \ \ o itsParagraph = aCtxParagraph(theContent, thePosition)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBC>(o, pos):

    \ \ \ \ <with|font-family|rm|Met <verbatim|\<less\>/> in the source. The
    previous context is a long tag. The parser leaves the>

    \ \ \ \ <with|font-family|rm|document context, and goes back to the long
    tag context which enters it's final>

    \ \ \ \ <with|font-family|rm|stage. (this method is only called by
    <verbatim|aCtxParagraph.finalizeLast>)>

    \ \ \ \ parent = o itsParent

    \ \ \ \ parent final = True

    \ \ \ \ o quit()

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBM>(o, pos):

    \ \ \ \ <with|font-family|rm|Met <verbatim|\<less\>\|> in the source.
    (only called by <verbatim|aCtxParagraph.finalizeLast>)>

    \ \ \ \ o quit()

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evEOF>(o, pos):

    \ \ \ \ <with|color|dark green|if> o hasParent:

    \ \ \ \ \ \ <with|font-family|rm|Should not be here.>

    \ \ \ \ \ \ <with|color|dark green|raise> TexmacsParserError("EOF in
    inner document context")

    \;

    \ \ <with|color|dark red|def> <with|color|blue|quit>(o):

    \ \ \ \ <with|font-family|rm|The quit procedure for a document is
    special: if the tree has a unique subtree>

    \ \ \ \ <with|font-family|rm|and this unique subtree is a collection, the
    collection's tree replaces the document.>

    \ \ \ \ <with|color|dark green|if> ((len(o itsTree) == 1) and

    \ \ \ \ \ \ \ \ \ \ \ \ \ (not o itsTree[0] title) <with|color|dark
    green|and> o itsTree[0] isCollection):

    \ \ \ \ \ \ o itsParent itsTree[-1] = o itsTree[0]

    \ \ \ \ aCtxBase quit(o)

    \;

    doDeclareAlias("aCtxDocument", "document parsing context")

    \;
  </code>

  <subsection|The texmacs tags contexts>

  There are 2 kinds of texmacs tags

  <\enumerate-roman>
    <item>Short tags: <verbatim|\<less\>label\|...\<gtr\>>

    <item>Long tags: <verbatim|\<less\>\\label\|...\<gtr\> ...
    \<less\>\|label\|...\<gtr\> ... \<less\>/label\|...\<gtr\>>
  </enumerate-roman>

  The parser will be in a tag context between the
  <verbatim|\<less\>...\<gtr\>>. This context has subcontexts within the
  arguments. Note that for long tags, the same context object is used for all
  the bracket pairs <verbatim|\<less\>\\...\<gtr\>, \<less\>\|...\<gtr\>,
  \<less\>/...\<gtr\>>. When the last pair of brackets is parsed, we say that
  the long tag context is in it's <em|final> stage.

  <subsubsection|A base class for tag contexts>

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxTag>(aCtxBase):

    \ \ <with|font-family|rm|<math|\<nearrow\>> Base class for both tag
    contexts.>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    theLabelPos):

    \ \ \ \ aCtxBase __init__(o, theContent)

    \ \ \ \ o itsLabelPos = theLabelPos <with|font-family|rm|<math|\<leftarrow\>>
    label's first letter's position.>

    \ \ \ \ o itsTree = None <with|font-family|rm|<math|\<leftarrow\>> tree
    creation is postponed until the first <verbatim|\|> or
    <verbatim|\<gtr\>>>

    \ \ \ \ o itsParent \<less\>\<less\> o

    \ \ \ \ <with|font-family|rm|(need to read the label before choosing the
    tree class)>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evM>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> called only on the first
    <verbatim|\|> after the label.>

    \ \ \ \ o createTree(pos)

    \ \ \ \ aCtxArgument(o itsContent, pos+1)
    <with|font-family|rm|<math|\<leftarrow\>> push an argument context.>

    \;

    \ \ <with|color|dark red|def> <with|color|blue|createTree>(o,
    posAfterLabel):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Creates a tree which
    class depends on the tag label.>

    \ \ \ \ theLabel = o getLabel(posAfterLabel)

    \ \ \ \ theClassName = aTmTree tmTagToWord(theLabel)

    \ \ \ \ o itsTree = TheTmTreeClasses[theClassName]()

    \ \ \ \ o itsParent itsTree[-1] = o itsTree

    \;

    \ \ <with|color|dark red|def> <with|color|blue|getLabel>(o,
    posAfterLabel):

    \ \ \ \ s = o itsContent[o itsLabelPos: posAfterLabel]

    \ \ \ \ decoded = theEncodingModule texmacsDecode(s)

    \ \ \ \ <with|color|dark green|return> decoded
  </code>

  <subsubsection|Short tag context>

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxShortTag>(aCtxTag):

    \ \ <with|font-family|rm|<math|\<nearrow\>> This is the context for short
    tags <verbatim|\<less\>label\|...\<gtr\>>.>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    thePosition):

    \ \ \ \ <with|font-family|rm|The label starts just after the
    <verbatim|\<less\>> 's position. <math|\<searrow\>>>

    \ \ \ \ aCtxTag __init__(o, theContent, thePosition + 1)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evE>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> Met <verbatim|\<gtr\>> in the
    source, only when there was no argument.>

    \ \ \ \ <with|color|dark green|assert>(o itsTree <with|color|dark
    green|is> None)

    \ \ \ \ o createTree(pos)

    \ \ \ \ o evE2(pos)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evE2>(o, pos):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Met <verbatim|\<gtr\>> in
    the source after the context's tree was created.>

    \ \ \ \ parent = o itsParent

    \ \ \ \ o quit()

    \ \ \ \ parent evTag(pos, o) <with|font-family|rm|<math|\<leftarrow\>>
    send <verbatim|evTag> to the parent context.>
  </code>

  <subsubsection|Long tag context>

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxLongTag>(aCtxTag):

    \ \ <with|font-family|rm|<math|\<nearrow\>> This is the context for long
    tags <verbatim|\<less\>\\label\|...\<gtr\> ...
    \<less\>/label\|...\<gtr\>>.>

    \ \ <with|font-family|rm|The same tag context holds in all pairs of
    brackets.>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    thePosition):

    \ \ \ \ <with|font-family|rm|The label starts just after the
    <verbatim|\<less\>\\>'s position. <math|\<searrow\>>>

    \ \ \ \ aCtxTag __init__(o, theContent, thePosition + 2)

    \ \ \ \ o final = False <with|font-family|rm|<math|\<leftarrow\>> will be
    true only in the <verbatim|\<less\>/...\<gtr\>> bracket.>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evE>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> Met <verbatim|\<gtr\>> in the
    source, only when there was no argument.>

    \ \ \ \ <with|color|dark green|if> o itsTree <with|color|dark green|is>
    None: <with|font-family|rm|<math|\<leftarrow\>> we're at the end of the
    first <verbatim|\<less\>\\...\<gtr\>> bracket.>

    \ \ \ \ \ \ label = o getLabel(pos)

    \ \ \ \ \ \ <with|color|dark green|if> label == "collection":

    \ \ \ \ \ \ \ \ <with|font-family|rm|A special collection context
    <em|replaces> the current context.>

    \ \ \ \ \ \ \ \ parent = o itsParent

    \ \ \ \ \ \ \ \ o quit()

    \ \ \ \ \ \ \ \ c = aCtxCollection(o itsContent)

    \ \ \ \ \ \ \ \ parent itsTree[-1] = c itsTree

    \ \ \ \ \ \ \ \ <with|color|dark green|return>

    \ \ \ \ o evE2(pos) <with|font-family|rm|<math|\<leftarrow\>> if we're
    not at the beginning of a collection, send <verbatim|evE2>.>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evE2>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> called on <verbatim|\<gtr\>> in
    all cases (and we're not in a collection)>

    \ \ \ \ <with|color|dark green|if> o final:
    <with|font-family|rm|<math|\<leftarrow\>> we're at the end of the closing
    <verbatim|\<less\>/...\<gtr\>>.>

    \ \ \ \ \ \ parent = o itsParent

    \ \ \ \ \ \ o quit()

    \ \ \ \ \ \ parent evTag(pos, o) <with|font-family|rm|<math|\<leftarrow\>>
    send <verbatim|evTag> to the parent context.>

    \ \ \ \ <with|color|dark green|else>:
    <with|font-family|rm|<math|\<leftarrow\>> we're at the end of
    <verbatim|\<less\>\\...\<gtr\>> or <verbatim|\<less\>\|...\<gtr\>>.>

    \ \ \ \ \ \ <with|color|dark green|if> o itsTree <with|color|dark
    green|is> None: <with|font-family|rm|<math|\<leftarrow\>> we're at the
    end of <verbatim|\<less\>\\...\<gtr\>> without argument.>

    \ \ \ \ \ \ \ \ o createTree(pos)

    \ \ \ \ \ \ <with|font-family|rm|<math|\<searrow\>> A new document is
    pushed to hold the text before the next bracket.>

    \ \ \ \ \ \ aCtxDocument(o itsContent, pos + 2)
    <with|font-family|rm|<math|\<leftarrow\>> skip <verbatim|\<gtr\>\\n> in
    source ?>

    \ \ \ \ \ \ <with|font-family|rm|Note that the new context should be the
    document's first paragraph.>
  </code>

  <subsection|The concat contexts>

  There are 2 contexts of this kind: the paragraphs and the texmacs tags
  arguments. These contexts contain the useful text in a texmacs file.

  <subsubsection|A base class for concat contexts>

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxConcat>(aCtxBase):

    \ \ <with|font-family|rm|<math|\<nearrow\>> Base class for contexts which
    contain text strings (paragraphs and args of tag).>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    theStartPosition):

    \ \ \ \ aCtxBase __init__(o, theContent)

    \ \ \ \ o itsStartPosition = theStartPosition

    \ \ \ \ o itsTree = TheTmTreeClasses["tm_concat"]()

    \ \ \ \ o itsParent \<less\>\<less\> o

    \;

    \ \ <with|color|dark red|def> <with|color|blue|storeText>(o, pos, start =
    None):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> append the text until
    <verbatim|pos> to the context's tree.>

    \ \ \ \ <with|color|dark green|if> o itsStartPosition \<less\> pos:

    \ \ \ \ \ \ s = o itsContent[o itsStartPosition: pos]

    \ \ \ \ \ \ o itsTree append(theEncodingModule texmacsDecode(s))

    \ \ \ \ o itsStartPosition = pos <with|color|dark green|if>(start
    <with|color|dark green|is> None) <with|color|dark green|else> start

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evB>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> a <verbatim|\<less\>> is
    encountered, opening a short tag context.>

    \ \ \ \ <with|font-family|rm|This is where short tag contexts are opened
    (and also in collections).>

    \ \ \ \ o storeText(pos)

    \ \ \ \ aCtxShortTag(o itsContent, pos)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBO>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> a <verbatim|\<less\>\\> is
    encountered, opening a long tag context.>

    \ \ \ \ <with|font-family|rm|This is where long tag contexts are opened
    (and also in collections).>

    \ \ \ \ o storeText(pos)

    \ \ \ \ aCtxLongTag(o itsContent, pos)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBS>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> a <verbatim|\<less\>#> is
    encountered, opening a raw data context.>

    \ \ \ \ o storeText(pos)

    \ \ \ \ aCtxRawData(o itsContent, pos)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evTag>(o, pos, theTag):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> call when a child tag
    just closed.>

    \ \ \ \ o itsStartPosition = pos + 1

    \;

    \ \ <with|color|dark red|def> <with|color|blue|finalize>(o):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> At the end of the concat
    context, if the tree has a single child, it's replaced>

    \ \ \ \ <with|font-family|rm|by this child.>

    \ \ \ \ <with|color|dark green|if> len(o itsTree) == 1:

    \ \ \ \ \ \ o itsParent itsTree[-1] = o itsTree[0]
  </code>

  <subsubsection|The paragraph context>

  Paragraph contexts are the child contexts of document contexts

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxParagraph>(aCtxConcat):

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    theStartPosition):

    \ \ \ \ aCtxConcat __init__(o, theContent, theStartPosition)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evDN>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\\n\\n> in the
    source.>

    \ \ \ \ <with|font-family|rm|This means the end of the current paragraph
    and the beginning of a new one.>

    \ \ \ \ o storeText(pos)

    \ \ \ \ o finalize()

    \ \ \ \ o quit()

    \ \ \ \ aCtxParagraph(o itsContent, pos + 2)
    <with|font-family|rm|<math|\<leftarrow\>> skip the <verbatim|\\n\\n> in
    the source.>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBM>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<less\>\|> in
    the source.>

    \ \ \ \ <with|font-family|rm|This implies that the current paragraph is
    the last one in the parent document.>

    \ \ \ \ o finalizeLast(pos, pos-1, "evBM")
    <with|font-family|rm|<math|\<leftarrow\>>ignore a <verbatim|\\n> ?>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBC>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<less\>/> in the
    source.>

    \ \ \ \ <with|font-family|rm|This implies that the current paragraph is
    the last one in the parent document.>

    \ \ \ \ o finalizeLast(pos, pos-1, "evBC")
    <with|font-family|rm|<math|\<leftarrow\>> ignore a <verbatim|\\n> ?>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evEOF>(o, pos):

    \ \ \ \ o finalizeLast(pos, pos, "evEOF")

    \;

    \ \ <with|color|dark red|def> <with|color|blue|finalizeLast>(o, pos, end,
    theEventName):

    \ \ \ \ parent = o itsParent

    \ \ \ \ o storeText(end)

    \ \ \ \ o finalize()

    \ \ \ \ o quit()

    \ \ \ \ getattr(parent, theEventName)(pos)
    <with|font-family|rm|<math|\<leftarrow\>>propagate the event to the
    parent.>
  </code>

  <subsubsection|The tag argument context>

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxArgument>(aCtxConcat):

    \ \ <with|font-family|rm|<math|\<nearrow\>> A context class for the tag's
    horizontal arguments.>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    theStartPosition):

    \ \ \ \ aCtxConcat __init__(o, theContent, theStartPosition)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evM>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\|> in the
    source.>

    \ \ \ \ <with|font-family|rm|This means the end of the argument and the
    beginning of another.>

    \ \ \ \ o storeText(pos)

    \ \ \ \ o finalize()

    \ \ \ \ o quit()

    \ \ \ \ aCtxArgument(o itsContent, pos + 1)
    <with|font-family|rm|<math|\<leftarrow\>> skip the <verbatim|\|>.>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evE>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<gtr\>> in the
    source.>

    \ \ \ \ o storeText(pos)

    \ \ \ \ o finalize()

    \ \ \ \ parent = o itsParent

    \ \ \ \ o quit() <with|font-family|rm|<math|\<leftarrow\>> close the
    current context.>

    \ \ \ \ parent evE2(pos) <with|font-family|rm|<math|\<leftarrow\>> pass
    the end of tag event to the parent tag.>
  </code>

  <subsection|The raw data context>

  This context holds in a <verbatim|\<less\>#...\<gtr\>> bloc of the texmacs
  source.

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxRawData>(aCtxBase):

    \ \ <with|font-family|rm|<math|\<nearrow\>> A class for raw data blocs
    like <verbatim|\<less\>#...\<gtr\>> of texmacs files.>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent,
    thePosition):

    \ \ \ \ aCtxBase __init__(o, theContent)

    \ \ \ \ o itsStartPositon = thePosition + 2
    <with|font-family|rm|<math|\<leftarrow\>> skip the <verbatim|\<less\>#>
    marker.>

    \ \ \ \ o itsTree = TheTmTreeClasses("tm_raw_data")()

    \ \ \ \ o itsParent \<less\>\<less\> o

    \;

    \ \ <with|color|dark red|def> <with|color|blue|evE>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<gtr\>> in the
    source <math|\<Rightarrow\>> end of the raw data context.>

    \ \ \ \ hs = o itsContent[o itsStartPosition: pos]

    \ \ \ \ s = binascii unhexlify(hs) <with|font-family|rm|<math|\<leftarrow\>>
    decode the binary data.>

    \ \ \ \ o itsTree append(s)

    \ \ \ \ parent = o itsParent

    \ \ \ \ o quit()

    \ \ \ \ parent evTag(pos, o) <with|font-family|rm|<math|\<leftarrow\>>
    pass a tag event to the parent context.>
  </code>

  <subsection|The collection context>

  <\code>
    @@ py context

    \;

    <with|color|dark red|class> <with|color|#800080|aCtxCollection>(aCtxBase):

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, theContent):

    \ \ \ \ aCtxBase __init__(o, theContent)

    \ \ \ \ o itsTree = TheTmTreeClasses["tm_collection"]()

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evB>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<less\>> in the
    source, beginning of a short tag child.>

    \ \ \ \ aCtxShortTag(o itsContent, pos)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBO>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<less\>\\> in
    the source, beginning of a long tag child.>

    \ \ \ \ aCtxLongTag(o itsContent, pos)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evBC>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<less\>/> in the
    source, beginning of the closing tag.>

    \ \ \ \ <with|color|dark green|pass>

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|def> <with|color|blue|evE>(o, pos):
    <with|font-family|rm|<math|\<leftarrow\>> met <verbatim|\<gtr\>> in the
    source, end of the closing tag only.>

    \ \ \ \ parent = o itsParent

    \ \ \ \ o quit()

    \ \ \ \ parent evTag(pos, o)

    \;

    \ \ @eventHandler

    \ \ <with|color|dark red|proc> <with|color|blue|evTag>(o, *args):
    <with|font-family|rm|<math|\<leftarrow\>> a child tag just closed.>

    \ \ \ \ <with|color|dark green|pass>
  </code>

  <section|Generating parse events>

  After superflous white space has been removed, the texmacs parser generates
  a sequence of <em|parse events>. Each generated event is a pair
  <verbatim|(<with|font-shape|italic|event name>,
  <with|font-shape|italic|position>)> where the event name is a string
  describing the event and the position is the index where it occured in the
  source string. This step can be isolated in a separate module

  <\code>
    @@ py generateEvents

    <with|color|dark green|from> quailCenter <with|color|dark green|import>
    doDeclareAlias

    doDeclareAlias("", "the parsing events module")

    <with|color|dark green|import> re

    \;

    theEventMap = \ { <with|font-family|rm|<math|\<leftarrow\>> associates
    substrings found in texmacs files to event names.>

    \ \ \ \ "\\n\\n": "evDN", <with|font-family|rm|<math|\<leftarrow\>> event
    Double Newline>

    \ \ \ \ "\<less\>" \ \ : "evB", \ <with|font-family|rm|<math|\<leftarrow\>>
    event Begin>

    \ \ \ \ "\<less\>\\\\" : "evBO", <with|font-family|rm|<math|\<leftarrow\>>
    event Begin Open>

    \ \ \ \ "\<less\>\|" \ : "evBM", <with|font-family|rm|<math|\<leftarrow\>>
    event Begin Middle>

    \ \ \ \ "\<less\>/" \ : "evBC", <with|font-family|rm|<math|\<leftarrow\>>
    event Begin Close>

    \ \ \ \ "\<less\>#" \ : "evBS", <with|font-family|rm|<math|\<leftarrow\>>
    event Begin Sharp>

    \ \ \ \ "\|" \ \ : "evM", \ <with|font-family|rm|<math|\<leftarrow\>>
    event Middle>

    \ \ \ \ "\<gtr\>" \ \ : "evE", \ <with|font-family|rm|<math|\<leftarrow\>>
    event End>

    \ \ }

    \;

    <with|color|dark red|def> <with|color|blue|theParseEvents>():

    \ \ <with|font-family|rm|Generate all event names.>

    \ \ <with|font-family|rm|Two events are not associated with strings in
    texmacs files:>

    \ \ <with|color|dark green|yield> "evEOF"
    \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>> event End Of File>

    \ \ <with|color|dark green|yield> "evT"
    \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>> event Tag>

    \ \ <with|color|dark green|for> name <with|color|dark green|in>
    theEventMap.values():

    \ \ \ \ <with|color|dark green|yield> name

    doDeclareAlias("theParseEvents", "the parsing events names")

    \;

    _thePattern = re.compile(r"""

    \ \ \ \ \\\\. \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\> >
    any escaped character (it can't be a newline)>

    \ \ \| \\n{2} \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\> \ >or a
    double newline>

    \ \ \| [\<less\>] \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>
    \ >or a begin tag character, optionally followed by:>

    \ \ \ \ [\\\\ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\> \ >
    \ \ <math|\<bullet\>> a backslash>

    \ \ \ \ \ \| \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\> \ >
    \ \ <math|\<bullet\>> or a vertical bar>

    \ \ \ \ \ / \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\> \ >
    \ \ <math|\<bullet\>> or a slash>

    \ \ \ \ \ #]? \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\> \ >
    \ \ <math|\<bullet\>> or a sharp sign>

    \ \ \| [\|] \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\> \ >or
    a vertical bar>

    \ \ \| [\<gtr\>] \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>
    \ >or an end of tag character>

    """, re.VERBOSE)

    \;

    <with|color|dark red|def> <with|color|blue|generateEvents>(theString):

    \ \ <with|font-family|rm|The parse events generator.>

    \ \ <with|color|dark green|for> match <with|color|dark green|in>
    _thePattern finditer(theString):

    \ \ \ \ s = match group(0)

    \ \ \ \ <with|font-family|rm|A test showed that 1/3 of the matches is an
    escaped character.>

    \ \ \ \ <with|font-family|rm|This test has a cost for each match but
    avoids <math|1/3> of function calls.>

    \ \ \ \ <with|color|dark green|if> s[0] != "\\\\":

    \ \ \ \ \ \ <with|color|dark green|yield> (theEventMap[s], match start())

    doDeclareAlias("generateEvents", "generate parsing events")
  </code>

  <section|Removing leading white space>

  In a texmacs document, the white space at the beginning of lines is not
  significant, nor are escaped newlines, which mean line continuation. As a
  preliminary step, the texmacs parser removes this non significant elements
  from the page content. This can be easily implemented as a separate module,
  and results in a callable, <verbatim|removeLeadingWhite>. Here is the
  implementation of this module (there is an alternate implementation in the
  experimental quail version, which should be compared to this one).

  <\code>
    @@ py removeLeadingWhite

    <with|color|dark green|from> quailCenter <with|color|dark green|import>
    quailGet, doDeclareAlias

    doDeclareAlias("", "the remove leading white space module")

    \;

    <with|color|dark green|import> re

    _thePattern = re.compile(r"""

    \ \ (

    \ \ \ \ (?: \\\\. \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>> any
    escaped character, except escaped newline>

    \ \ \ \ \ \| \ [^\\\\\\n] \ <with|font-family|rm|<math|\<leftarrow\>> or
    any character but newline or backslash>

    \ \ \ \ )* \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    zero or more such items>

    \ \ ) \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    this is <verbatim|group(1)>>

    \ \ ( \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|followed by:>

    \ \ \ \ \\\\? \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    an optional backslash>

    \ \ \ \ \\n \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    a newline>

    \ \ \ \ [\\ \\f\\r\\t]* \ <with|font-family|rm|<math|\<leftarrow\>> zero
    or more white non newline characters>

    \ \ ) \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    this is <verbatim|group(2)>>

    \ \ <with|font-family|rm|This pattern will be replaced by group 1
    followed by <verbatim|\\n> \ if group 2 starts with <verbatim|\\n>.>

    """, re.VERBOSE)

    \;

    <with|color|dark red|class> <with|color|#800080|_aLeadingWhiteRemover>(object):

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o):

    \ \ \ \ <with|color|dark green|pass>

    \ \ <with|color|dark red|def> <with|color|blue|__call__>(o, theString):

    \ \ \ \ <with|color|dark green|return> _thePattern.sub(o subProc,
    theString)

    \ \ <with|color|dark red|def> <with|color|blue|subProc>(o, mo):

    \ \ \ \ <with|color|dark green|return> (mo.group(1)+"\\n"
    <with|color|dark green|if> mo.group(2).startswith("\\n")

    \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark green|else> mo.group(1))

    \;

    removeLeadingWhite = _aLeadingWhiteRemover()

    doDeclareAlias("removeLeadingWhite", "remove leading white space")
  </code>

  <section|Text encoding in texmacs files>

  In the texmacs format, ordinary strings of text are encoded, some
  characters are escaped with backslashes or replaced by other characters. A
  particular case is the encoding of space characters <verbatim|" "> between
  words. Texmacs uses this character to generate line breaks in the formatted
  file. Depending on the context, this character can be encoded as
  <verbatim|" ">, or <verbatim|"\\\\ "> or <verbatim|"\\n"> if it breaks a
  line.

  This module defines 2 functions

  <\itemize-minus>
    <item><verbatim|texmacsEncode(string, cut)>

    <item><verbatim|texmacsDecode(string)>
  </itemize-minus>

  The <verbatim|cut> argument of <verbatim|texmacsEncode> allows a writer to
  choose the correct coding for the space character. <verbatim|texmacsDecode>
  is used by the parser to store the actual strings of text in the parsed
  texmacs trees.

  <\code>
    @@ py encoding

    <with|color|dark green|from> quailCenter <with|color|dark green|import>
    doDeclareAlias

    doDeclareAlias("", "the texmacs text encoding module")

    <with|color|dark green|import> re

    \;

    <with|color|dark red|class> <with|color|#800080|_anEncoder>(object):

    \;

    \ \ _theDecodeMap = {

    \ \ \ \ r"\\0":"\\0", <with|font-family|rm|<math|\<leftarrow\>> backslash
    and zero is mapped to character <verbatim|\\0>>

    \ \ \ \ r"\\t":"\\t", <with|font-family|rm|<math|\<leftarrow\>> same for
    backslash and t, r, n or <verbatim|\\>>

    \ \ \ \ r"\\r":"\\r",

    \ \ \ \ r"\\n":"\\n",

    \ \ \ \ r"\\\\": "\\\\",

    \ \ \ \ r"\\ ": " ", <with|font-family|rm|<math|\<leftarrow\>> backslash
    and space is mapped to space.>

    \ \ \ \ r"\\;":"", \ \ <with|font-family|rm|<math|\<leftarrow\>>
    backslash semicolon is mapped to the empty string.>

    \ \ \ \ "\\n" : " ", <with|font-family|rm|<math|\<leftarrow\>> newline is
    mapped to space.>

    \ \ }

    \;

    \ \ _theDecodePattern = re compile(r"""

    \ \ \ \ \ \\n \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    newline>

    \ \ \ \| \\\\ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    or backslash ...>

    \ \ \ \ \ (?: \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    followed by>

    \ \ \ \ \ \ \ [0trn;\\\\\\ ] \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    <verbatim|0 t r n ; \\> or space>

    \ \ \ \ \ \ \ \|\\n \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    or newline>

    \ \ \ \ \ \ \ \|([@-_]) \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    or a character between <verbatim|@> and underscore (group(1))>

    \ \ \ \ \ \ \ \|. \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    or another character>

    \ \ \ \ \ )

    """, re VERBOSE)

    \ \ _ordAt = ord("@") <with|font-family|rm|<math|\<leftarrow\>> this is
    64.>

    \;

    \ \ <with|color|dark red|def> <with|color|blue|subDecode>(o, match):

    \ \ \ \ s = match group(0)

    \ \ \ \ <with|color|dark green|if> match group(1):

    \ \ \ \ \ \ <with|color|dark green|return> chr(ord(s[-1]) - o _ordAt)

    \ \ \ \ <with|color|dark green|else>:

    \ \ \ \ \ \ <with|color|dark green|return> o _theDecodeMap get(s, s[-1])

    \ \ \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> by default, an
    escaped character is mapped to this character,>

    \ \ \ \ \ \ <with|font-family|rm|unless it's in the map.>

    \;

    \ \ <with|color|dark red|def> <with|color|blue|texmacsDecode>(o, s):

    \ \ \ \ <with|color|dark green|return> o _theDecodePattern sub(o
    subDecode, s)

    \;

    \ \ _theEncodeMap = {

    \ \ \ \ "\\n": r"\\n",

    \ \ \ \ "\\t": r"\\t",

    \ \ \ \ "\\0": r"\\0",

    \ \ \ \ "\\\\": r"\\\\",

    \ \ \ \ "\<less\>": r"\\\<less\>",

    \ \ \ \ "\|": r"\\\|",

    \ \ \ \ "\<gtr\>": r"\\\<gtr\>",

    \ \ \ \ "\\34": "\\34", <with|font-family|rm|<math|\<leftarrow\>> octal
    34 (ascii 28, hex <verbatim|\\x1c> symbol FS) or file separator.>

    \ \ }

    \;

    \ \ _theEncodePattern = re compile(r"""

    \ \ \ \ [\\x00-\\x1f \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    a character between ascii 0 and 31 included>

    \ \ \ \ \ \\n\\t\\\\\<less\>\|\<gtr\>]
    \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>> or character in the
    map>

    \ \ \ \ \| [\\ ]+ \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<leftarrow\>>
    or 1 or more spaces>

    \ \ """, re.VERBOSE)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|subEncode>(o, match):

    \ \ \ \ c = match group(0)

    \ \ \ \ <with|color|dark green|if> c <with|color|dark green|in> o
    _theEncodeMap:

    \ \ \ \ \ \ <with|color|dark green|return> o _theEncodeMap[c]

    \ \ \ \ <with|color|dark green|elif> c[0] == " ":

    \ \ \ \ \ \ <with|color|dark green|return> "\\n" + ("\\\\ " * (len(c) -
    1))

    \ \ \ \ \ \ <with|font-family|rm|The first <math|\<nearrow\>> space in a
    sequence is replaced by <verbatim|"\\n"> and later by the cut arg.>

    \ \ \ \ <with|color|dark green|else>:

    \ \ \ \ \ \ <with|color|dark green|return> "\\\\" + chr(o _ordAt +
    ord(c))

    \;

    \ \ <with|color|dark red|def> <with|color|blue|texmacsEncode>(o, s, cut):

    \ \ \ \ <with|font-family|rm|<em|cut> is the encoding to use for the cut
    character.>

    \ \ \ \ <with|font-family|rm|In ordinary text, the cut character is the
    first space between 2 words.>

    \ \ \ \ s = o _theEncodePattern sub(o subEncode, s)

    \ \ \ \ <with|color|dark green|return> s.replace("\\n", cut)

    \;

    _theEncoder = _anEncoder()

    \;

    texmacsEncode = _theEncoder texmacsEncode

    texmacsDecode = _theEncoder texmacsDecode

    \;
  </code>

  \;

  <action|EXPAND|(quail "expand()")>
</body>

<\initial>
  <\collection>
    <associate|bg-color|#e0e0e0>
    <associate|language|english>
    <associate|magnification|1.1>
    <associate|page-type|# Simply write the paper name. See papersize(5) for
    possible values.>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|?|?>>
    <associate|auto-10|<tuple|2.5.2|?>>
    <associate|auto-11|<tuple|2.5.3|?>>
    <associate|auto-12|<tuple|2.6|?>>
    <associate|auto-13|<tuple|2.6.1|?>>
    <associate|auto-14|<tuple|2.6.2|?>>
    <associate|auto-15|<tuple|2.6.3|?>>
    <associate|auto-16|<tuple|2.7|?>>
    <associate|auto-17|<tuple|2.8|?>>
    <associate|auto-18|<tuple|3|?>>
    <associate|auto-19|<tuple|4|?>>
    <associate|auto-2|<tuple|1|?>>
    <associate|auto-20|<tuple|5|?>>
    <associate|auto-3|<tuple|2|?>>
    <associate|auto-4|<tuple|2.1|?>>
    <associate|auto-5|<tuple|2.2|?>>
    <associate|auto-6|<tuple|2.3|?>>
    <associate|auto-7|<tuple|2.4|?>>
    <associate|auto-8|<tuple|2.5|?>>
    <associate|auto-9|<tuple|2.5.1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Table
      of contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1.<space|2spc>The
      parser> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|2.<space|2spc>The
      different parsing contexts> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|2.1.<space|2spc>Parser error exception
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|2.2.<space|2spc>The event handler
      decorator <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|2.3.<space|2spc>The base context class
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|1.5fn>|2.4.<space|2spc>The document context
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|1.5fn>|2.5.<space|2spc>The texmacs tags contexts
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>

      <with|par-left|<quote|3fn>|2.5.1.<space|2spc>A base class for tag
      contexts <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-9>>

      <with|par-left|<quote|3fn>|2.5.2.<space|2spc>Short tag context
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-10>>

      <with|par-left|<quote|3fn>|2.5.3.<space|2spc>Long tag context
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-11>>

      <with|par-left|<quote|1.5fn>|2.6.<space|2spc>The concat contexts
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-12>>

      <with|par-left|<quote|3fn>|2.6.1.<space|2spc>A base class for concat
      contexts <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-13>>

      <with|par-left|<quote|3fn>|2.6.2.<space|2spc>The paragraph context
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-14>>

      <with|par-left|<quote|3fn>|2.6.3.<space|2spc>The tag argument context
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-15>>

      <with|par-left|<quote|1.5fn>|2.7.<space|2spc>The raw data context
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-16>>

      <with|par-left|<quote|1.5fn>|2.8.<space|2spc>The collection context
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-17>>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|3.<space|2spc>Generating
      parse events> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-18><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|4.<space|2spc>Removing
      leading white space> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-19><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|5.<space|2spc>Text
      encoding in texmacs files> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-20><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>